SystemOrganization addCategory: #'ParallelPort-Model'!
SystemOrganization addCategory: #'ParallelPort-Morph'!

Morph subclass: #GenericParallelPortMorph
	instanceVariableNames: 'dataPort statusPort controlPort'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParallelPort-Morph'!

GenericParallelPortMorph class
	instanceVariableNames: 'form'!

GenericParallelPortMorph class
	instanceVariableNames: 'form'!

!GenericParallelPortMorph class methodsFor: 'viewer categories' stamp: 'Richo 8/6/2009 16:50'!
additionsToViewerCategories
^ #(
(#'all ports' (
#(slot pin1 '' Boolean readWrite Player getPin1 Player setPin1: )
#(slot pin2 '' Boolean readWrite Player getPin2 Player setPin2: )
#(slot pin3 '' Boolean readWrite Player getPin3 Player setPin3: )
#(slot pin4 '' Boolean readWrite Player getPin4 Player setPin4: )
#(slot pin5 '' Boolean readWrite Player getPin5 Player setPin5: )
#(slot pin6 '' Boolean readWrite Player getPin6 Player setPin6:  )
#(slot pin7 '' Boolean readWrite Player getPin7 Player setPin7:  )
#(slot pin8 '' Boolean readWrite Player getPin8 Player setPin8:  )
#(slot pin9 '' Boolean readWrite Player getPin9 Player setPin9:  )
#(slot pin10 '' Boolean readOnly Player getPin10 Player unused )
#(slot pin11 '' Boolean readOnly Player getPin11 Player unused )
#(slot pin12 '' Boolean readOnly Player getPin12 Player unused )
#(slot pin13 '' Boolean readOnly Player getPin13 Player unused )
#(slot pin14 '' Boolean readWrite Player getPin14 Player setPin14:  )
#(slot pin15 '' Boolean readOnly Player getPin15 Player unused )

#(slot pin16 '' Boolean readWrite Player getPin16 Player setPin16:  )
#(slot pin17 '' Boolean readWrite Player getPin17 Player setPin17:  )
))

(#'status port' (
#(slot pin10 '' Boolean readOnly Player getPin10 Player unused )
#(slot pin11 '' Boolean readOnly Player getPin11 Player unused )
#(slot pin12 '' Boolean readOnly Player getPin12 Player unused )
#(slot pin13 '' Boolean readOnly Player getPin13 Player unused )
#(slot pin15 '' Boolean readOnly Player getPin15 Player unused )
))

(#'data port' (
#(slot pin2 '' Boolean readWrite Player getPin2 Player setPin2: )
#(slot pin3 '' Boolean readWrite Player getPin3 Player setPin3: )
#(slot pin4 '' Boolean readWrite Player getPin4 Player setPin4: )
#(slot pin5 '' Boolean readWrite Player getPin5 Player setPin5: )
#(slot pin6 '' Boolean readWrite Player getPin6 Player setPin6:  )
#(slot pin7 '' Boolean readWrite Player getPin7 Player setPin7:  )
#(slot pin8 '' Boolean readWrite Player getPin8 Player setPin8:  )
#(slot pin9 '' Boolean readWrite Player getPin9 Player setPin9:  )
))

(#'control port' (
#(slot pin1 '' Boolean readWrite Player getPin1 Player setPin1: )
#(slot pin14 '' Boolean readWrite Player getPin14 Player setPin14:  )
#(slot pin16 '' Boolean readWrite Player getPin16 Player setPin16:  )
#(slot pin17 '' Boolean readWrite Player getPin17 Player setPin17:  )
))

)! !

!GenericParallelPortMorph class methodsFor: 'parts bin' stamp: 'Richo 4/7/2011 17:56'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self
		partName: 'Parallel port' translatedNoop
		categories: {'Electronics' translatedNoop}
		documentation: 'An object that you can use to access the pins of your parallel port' translatedNoop! !

!GenericParallelPortMorph class methodsFor: 'form' stamp: 'Richo 4/8/2011 13:05'!
form
"
form := nil
"
^form ifNil: [self initializeForm]! !

!GenericParallelPortMorph class methodsFor: 'form' stamp: 'Richo 4/8/2011 13:05'!
initializeForm
^form := PEUtilities formFromEncodedPNG:  'iVBORw0KGgoAAAANSUhEUgAAAWIAAAA3CAYAAAA2aECKAAADEElEQVR4XuXdTW7DMAxEYfv+
l/LN0kXRTYEY/hFFip+Bh6yKKTnQQIgVcTt/9o+Pj4+PzwhuP79/eByHj4+Pj88AbgayH8A+
Pj4+sYHsh7CPj49P1TD2Q9jHx8cnMYz974R9fHx8kr8z9kPYx8fHJ3FX7Iewj4+PT3IY+0Hs
4+Pj0zKIzw42r6TRqRZfw++X70mdWsKD+O+f/vaM0Jyh0akWX8Pvl+9JnVrCg/isiFEFzdDo
VIuv4ffL96ROLeFBfLWQNwXN0OhUi6/h98v3pE4t4UF8t5AnBc3Q6FSLr+H77ntSpxY/iP0F
6Wv4/fI9qR3EY84S++b7C9L33dfwPXn1M2c/iP3F4i96v1++J8lB/D6MffP9Ben77mv4nry+
gc0PYn+x+Ive75fvSXIQvwtj33x/Qfq++xq+J0Muh98/M8PYP7voa/i++xraOeKLI5P2sJ8H
/i/kacOiNTrV4mv4/fI9qVPLhd3wvDAeU0isRqdafA2/X74nlTRuTHH2b0nyb8jyfff75Xsy
VuPBWH3/nmIfHx+fgGkcfhD7+Pj4LBTEfhj7+Pj4JIewP93Zx8fHZ9x3zq8eP4h9fHx8knbD
fhj7+Pj4FAlhP4h9fHx8CgTxnDD2zzv6Gr7vvsaKnkwK4fgXd/60WV/D993XWNGTwBd0c3fF
/rRZX8P33ddY0ZPJu+G4MPZvifI1fN99jRU9SQzhLXX8vn9vqq/h++5rVNFJDuLNn/zsLxZf
w++XH8S5IewHsb9YfA2/X34QFwhif/Kzv1h8Db9ffhAnh/CY42y++f6C9H33NToEcfBxtdhd
sW++vyB9332NPkGc+viTn/3F4i96v19uEBcI4fm7Yv88qa/h++5rVDpHXCSI/cnP3WrxNfx+
+Z4sF8JjdsX+tFlfw/fd11jTk1KPP/nZvyHL993vl+NJwRD2xyp9xf/08WnHlntczb9A3sfH
x6dwCPth7OPj44ewH8Q+Pj4+fhD7Yezj4+OHsP/izsfHx8d7QeeHsY+Pjx/CfiD7+Pj4+AF8
PZB9fHx81mHO8wM1xgass9puJwAAAABJRU5ErkJggg=='! !

!GenericParallelPortMorph methodsFor: 'accessing' stamp: 'Richo 4/6/2011 11:24'!
bitFor: pinNumber
"Devuelve el nmero de bit para el puerto al que pertenece el pin"
^(Dictionary new 
at: 1 put: 1; 
at: 2 put: 1; 
at: 3 put: 2; 
at: 4 put: 3;
at: 5 put: 4;
at: 6 put: 5;
at: 7 put: 6;
at: 8 put: 7;
at: 9 put: 8;
at: 10 put: 7;
at: 11 put: 8;
at: 12 put: 6;
at: 13 put: 5;
at: 14 put: 2;
at: 15 put: 4;
at: 16 put: 3;
at: 17 put: 4;

yourself) at: pinNumber ifAbsent: [self error: 'Ground pin' translated]! !

!GenericParallelPortMorph methodsFor: 'accessing' stamp: 'Richo 6/2/2009 18:13'!
controlPins
	^ #(1 14 16 17)! !

!GenericParallelPortMorph methodsFor: 'accessing' stamp: 'Richo 6/2/2009 18:12'!
dataPins
^(2 to: 9)! !

!GenericParallelPortMorph methodsFor: 'drawing' stamp: 'Richo 6/9/2009 16:38'!
drawOn: aCanvas 

	aCanvas translucentImage: self class form at: self topLeft.! !

!GenericParallelPortMorph methodsFor: 'viewer category filter' stamp: 'Richo 12/28/2009 15:46'!
filterViewerCategoryDictionary: dict
| validCategories |
super filterViewerCategoryDictionary: dict.
validCategories := self validCategories.
dict keys do: [:each|
	(validCategories includes: each)
		ifFalse: [
			dict removeKey: each
			].
	]! !

!GenericParallelPortMorph methodsFor: 'actions' stamp: 'Richo 7/14/2009 21:30'!
getPinState: pinNumber
| port bit |
port := self portFor: pinNumber.
bit := self bitFor: pinNumber.
^port getBit: bit! !

!GenericParallelPortMorph methodsFor: 'accessing' stamp: 'Richo 6/2/2009 18:13'!
groundPins
	^ 18 to: 25! !

!GenericParallelPortMorph methodsFor: 'initialize-release' stamp: 'Richo 8/5/2009 13:00'!
initialize
	| base |
	super initialize.
	self extent: self class form extent;initializePins.

	base := 16r378.  
	dataPort := ParallelPort new port: base.
	statusPort:= ParallelPort new port: base + 1.
	controlPort :=  ParallelPort new port: base + 2.
	! !

!GenericParallelPortMorph methodsFor: 'initialize-release' stamp: 'Richo 7/14/2009 22:16'!
initializePins
| pin pos |
1 to: 25 do: [:i|
pos :=  self topLeft + (self pinPositions at: i).
(self dataPins includes: i) ifTrue: [
	pin := (GenericDataPinMorph pin: i)  center:pos].
(self statusPins includes: i) ifTrue: [
	pin := (GenericStatusPinMorph pin: i)  center:pos].
(self controlPins includes: i) ifTrue: [
	pin := (GenericControlPinMorph pin: i)  center:pos].
(self groundPins includes: i) ifTrue: [
	pin := (GenericGroundPinMorph pin: i)  center:pos].
self addMorph: pin.
]! !

!GenericParallelPortMorph methodsFor: 'initializing' stamp: 'Richo 7/29/2009 13:28'!
newPlayerInstance
^ GenericParallelPortPlayer newUserInstance! !

!GenericParallelPortMorph methodsFor: 'accessing' stamp: 'Richo 7/14/2009 14:59'!
pinPositions
	"Devuelve el centro de cada pin en pixeles (con respecto al topLeft)"
"	^ {25 @ 16. 50 @ 16. 76 @ 16. 101 @ 16. 126 @ 16. 151 @ 16. 176 @ 16. 202 @ 16. 227 @ 16. 252 @ 16. 277 @ 16. 303 @ 16. 328 @ 16. 38 @ 38. 63 @ 38. 89 @ 38. 114 @ 38. 139 @ 38. 164 @ 38. 189 @ 38. 215 @ 38. 240 @ 38. 265 @ 38. 290 @ 38. 316 @ 38}"
^{328@16. 303@16. 277@16. 252@16. 227@16. 202@16. 176@16. 151@16. 126@16. 101@16 .76@16. 50@16. 25@16 .316@38. 290@38. 265@38. 240@38. 215@38. 189@38 .164@38. 139@38. 114@38 .89@38. 63@38. 38@38}! !

!GenericParallelPortMorph methodsFor: 'accessing' stamp: 'Richo 4/6/2011 11:24'!
portFor: pinNumber
(self dataPins includes: pinNumber) ifTrue: [^dataPort].
(self statusPins includes: pinNumber) ifTrue: [^statusPort].
(self controlPins includes: pinNumber) ifTrue: [^controlPort].
self error: 'Gnd pin' translated! !

!GenericParallelPortMorph methodsFor: 'actions' stamp: 'Richo 8/5/2009 12:59'!
set: aBoolean onPin: pinNumber 
	| port bit |

	port := self portFor: pinNumber.
	bit := self bitFor: pinNumber.
	aBoolean ifTrue: [port setBit: bit] ifFalse: [port clearBit: bit]! !

!GenericParallelPortMorph methodsFor: 'accessing' stamp: 'Richo 6/2/2009 18:13'!
statusPins
	^ (10 to: 13) , #(15)! !

!GenericParallelPortMorph methodsFor: 'actions' stamp: 'Richo 7/29/2009 08:19'!
togglePin: pinNumber
| port bit |
port := self portFor: pinNumber.
bit := self bitFor: pinNumber.
port toggleBit: bit! !

!GenericParallelPortMorph methodsFor: 'viewer category filter' stamp: 'Richo 12/28/2009 15:46'!
validCategories
^self class additionsToViewerCategories collect: [:each| each first]! !

Morph subclass: #GenericPinMorph
	instanceVariableNames: 'number state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParallelPort-Morph'!

GenericPinMorph subclass: #GenericControlPinMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParallelPort-Morph'!

!GenericControlPinMorph methodsFor: 'as yet unclassified' stamp: 'Richo 4/6/2011 11:22'!
initialize
super initialize.
self on: #mouseUp send: #mouseUp to: self! !

!GenericControlPinMorph methodsFor: 'as yet unclassified' stamp: 'Richo 4/6/2011 11:21'!
myBalloonText
^'Control pin {1}
(input/output)' translated format: {number asString}! !

GenericPinMorph subclass: #GenericDataPinMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParallelPort-Morph'!

!GenericDataPinMorph methodsFor: 'as yet unclassified' stamp: 'Richo 7/29/2009 08:42'!
initialize
super initialize.
self on: #mouseUp send: #mouseUp to: self! !

!GenericDataPinMorph methodsFor: 'as yet unclassified' stamp: 'Richo 4/6/2011 11:21'!
myBalloonText
^'Data pin {1}
(output)' translated format: {number asString}! !

GenericPinMorph subclass: #GenericGroundPinMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParallelPort-Morph'!

!GenericGroundPinMorph class methodsFor: 'color constants' stamp: 'Richo 7/29/2009 08:24'!
offColor
	^Color gray! !

!GenericGroundPinMorph class methodsFor: 'color constants' stamp: 'Richo 7/29/2009 08:24'!
onColor
	^Color gray! !

!GenericGroundPinMorph methodsFor: 'as yet unclassified' stamp: 'Richo 4/6/2011 11:21'!
myBalloonText
^'Ground pin {1}' translated format: {number asString}! !

!GenericPinMorph class methodsFor: 'instance creation' stamp: 'Richo 7/14/2009 22:15'!
new
self shouldNotImplement! !

!GenericPinMorph class methodsFor: 'color constants' stamp: 'Richo 7/29/2009 08:23'!
offBorderColor
^self onBorderColor! !

!GenericPinMorph class methodsFor: 'color constants' stamp: 'Richo 7/29/2009 14:17'!
offColor
^Color red! !

!GenericPinMorph class methodsFor: 'color constants' stamp: 'Richo 7/29/2009 14:21'!
onBorderColor
^Color black! !

!GenericPinMorph class methodsFor: 'color constants' stamp: 'Richo 8/5/2009 15:52'!
onColor
^Color green! !

!GenericPinMorph class methodsFor: 'instance creation' stamp: 'Richo 7/14/2009 22:18'!
pin: aNumber
^(self basicNew number: aNumber) initialize! !

!GenericPinMorph methodsFor: 'drawing' stamp: 'Richo 7/29/2009 14:20'!
drawOn: aCanvas
aCanvas fillOval: self bounds color: self color borderWidth: 1 borderColor: self borderColor! !

!GenericPinMorph methodsFor: 'initialization' stamp: 'Richo 7/29/2009 08:41'!
initialize
super initialize.
self extent:17@17; setBalloonText: self myBalloonText.
self addMorph: ((number asString asMorph fontName: 'Accujen' size: 6) center: self center).

state := false.! !

!GenericPinMorph methodsFor: 'event handling' stamp: 'Richo 7/14/2009 21:33'!
mouseUp

[owner togglePin: number.
self refreshColors] on:Error do: [].! !

!GenericPinMorph methodsFor: 'accessing' stamp: 'Richo 7/29/2009 08:43'!
myBalloonText
self subclassResponsibility! !

!GenericPinMorph methodsFor: 'accessing' stamp: 'Richo 7/14/2009 22:18'!
number: aNumber
number := aNumber.! !

!GenericPinMorph methodsFor: 'drawing' stamp: 'Richo 7/14/2009 22:22'!
refreshColors

state ifTrue: [
	self color: self class onColor; borderColor: self class onBorderColor.
]
ifFalse: [
	self color: self class offColor; borderColor:self class offBorderColor.
]
! !

!GenericPinMorph methodsFor: 'stepping' stamp: 'Richo 7/14/2009 22:24'!
step
[state := owner getPinState: number]
on: Error do: [].
self refreshColors.! !

!GenericPinMorph methodsFor: 'stepping' stamp: 'Richo 7/14/2009 22:21'!
stepTime
^1! !

GenericPinMorph subclass: #GenericStatusPinMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParallelPort-Morph'!

!GenericStatusPinMorph methodsFor: 'as yet unclassified' stamp: 'Richo 4/6/2011 11:21'!
myBalloonText
^'Status pin {1}
(input)' translated format: {number asString}! !

Object subclass: #ParallelPort
	instanceVariableNames: 'port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParallelPort-Model'!

!ParallelPort class methodsFor: 'constants' stamp: 'Richo 8/5/2009 16:47'!
defaultPort
 ^ 16r378! !

!ParallelPort class methodsFor: 'instance creation' stamp: 'Richo 8/5/2009 12:19'!
new
 ^ SmalltalkImage current platformName = 'unix'
	ifTrue: [UnixParallelPort new]
	ifFalse: [WinParallelPort new] ! !

!ParallelPort methodsFor: '<information>' stamp: ''!
bitTransferSpeed
	| time iterations bitsPerIteration |
	iterations := 10000.
	bitsPerIteration := 4.
	time := Time
				millisecondsToRun: [1
						to: iterations
						do: [:i | 
							self class apiSetPortBit: self port location: 1.
							self class apiGetPortBit: self port location: 1.
							self class apiClrPortBit: self port location: 1.
							self class apiGetPortBit: self port location: 1].
					nil].
	^ (iterations * bitsPerIteration / (time / 1000) / 1024) asFloat! !

!ParallelPort methodsFor: '<information>' stamp: ''!
byteTransferSpeed
	| time iterations bitsPerIteration |
	iterations := 10000.
	bitsPerIteration := 16.
	time := Time
				millisecondsToRun: [1
						to: iterations
						do: [:i | 
							self class apiPortOut: self port data: 255.
							self class apiPortIn: self port].
					nil].
	^ (iterations * bitsPerIteration / (time / 1000) / 1024) asFloat! !

!ParallelPort methodsFor: '<io>' stamp: ''!
clearBit: anInteger 
	^ self class apiClrPortBit: self port location: anInteger - 1! !

!ParallelPort methodsFor: '<io>' stamp: ''!
clearPort
	^ self writePort: 0! !

!ParallelPort methodsFor: '<io>' stamp: ''!
getBit: anInteger 
	(self class apiGetPortBit: self port location: anInteger - 1)
			= -1
		ifTrue: [^ true].
	^ false! !

!ParallelPort methodsFor: '<port handling>' stamp: ''!
initializePort
	port := self class defaultPort! !

!ParallelPort methodsFor: '<information>' stamp: ''!
isDriverInstalled
	^ self class apiIsDriverInstalled ~= 0! !

!ParallelPort methodsFor: '<port handling>' stamp: ''!
port
	port isNil
		ifTrue: [self initializePort].
	^ port! !

!ParallelPort methodsFor: '<port handling>' stamp: ''!
port: anInteger 
	port := anInteger! !

!ParallelPort methodsFor: '<io>' stamp: ''!
readDWordPort
	^ (self class apiPortDWordIn: self port) asInteger! !

!ParallelPort methodsFor: '<io>' stamp: ''!
readPort
	^ (self class apiPortIn: self port) asInteger! !

!ParallelPort methodsFor: '<io>' stamp: ''!
readWordPort
	^ (self class apiPortWordIn: self port) asInteger! !

!ParallelPort methodsFor: '<io>' stamp: ''!
setBit: anInteger 
	^ self class apiSetPortBit: self port location: anInteger - 1! !

!ParallelPort methodsFor: '<io>' stamp: ''!
setPort
	^ self writePort: 255! !

!ParallelPort methodsFor: '<io>' stamp: ''!
singleBitShift: sideBoolean inject: aBoolean 
	sideBoolean
		ifTrue: [^ (self class
				apiLeftPortShift: self port
				data: (aBoolean
						ifTrue: [1]
						ifFalse: [0]))
				= -1].
	^ (self class
		apiRightPortShift: self port
		data: (aBoolean
				ifTrue: [1]
				ifFalse: [0]))
		= -1! !

!ParallelPort methodsFor: '<io>' stamp: ''!
toggleBit: anInteger 
	^ self class apiNotPortBit: self port location: anInteger - 1! !

!ParallelPort methodsFor: '<io>' stamp: ''!
writeDWordPort: anInteger 
	^ self class apiPortDWordOut: self port data: anInteger! !

!ParallelPort methodsFor: '<io>' stamp: ''!
writePort: aByte 
	^ self class apiPortOut: self port data: aByte! !

!ParallelPort methodsFor: '<io>' stamp: ''!
writeWordPort: anInteger 
	^ self class apiPortWordOut: self port data: anInteger! !

ParallelPort subclass: #UnixParallelPort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParallelPort-Model'!

!UnixParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:29'!
apiClrPortBit: port location: location
"libparallel.so.1.0.1"
	<apicall: void 'clearBit' (short short) module: 'libparallel.so.1.0.1'>
	^ self externalCallFailed! !

!UnixParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:49'!
apiGetPortBit: port location: aByte 
	<apicall: short 'getBit' (short short) module: 'libparallel.so.1.0.1'>
	^ self externalCallFailed! !

!UnixParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:29'!
apiNotPortBit: port location: location
"libparallel.so.1.0.1"
	<apicall: void 'toggleBit' (short short) module: 'libparallel.so.1.0.1'>
	^ self externalCallFailed! !

!UnixParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 11:12'!
apiSetPermissions: port num: num turnOn: turnOn
"libparallel.so.1.0.1"
	<apicall: short 'setPermissions' (short short short) module: 'libparallel.so.1.0.1'>
	^ self externalCallFailed! !

!UnixParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 11:11'!
apiSetPortBit: port location: location
"libparallel.so.1.0.1"
	<apicall: void 'setBit' (short short) module: 'libparallel.so.1.0.1'>
	^ self externalCallFailed! !

!UnixParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:00'!
apiTogglePortBit: port location: location
"libparallel.so.1.0.1"
	<apicall: void 'toggleBit' (short short) module: 'libparallel.so.1.0.1'>
	^ self externalCallFailed! !

!UnixParallelPort class methodsFor: 'class initialization' stamp: 'Richo 8/5/2009 17:30'!
initialize
"UnixParallelPort initialize"
Smalltalk addToStartUpList: self.! !

!UnixParallelPort class methodsFor: 'instance creation' stamp: 'Richo 8/5/2009 12:23'!
new
 ^ self basicNew! !

!UnixParallelPort class methodsFor: 'system startup' stamp: 'Richo 8/5/2009 17:28'!
startUp
self allInstancesDo: [:each| each setPermissions]! !

!UnixParallelPort methodsFor: 'as yet unclassified' stamp: 'Richo 8/5/2009 12:31'!
initializePort
	super initializePort.
	self setPermissions.! !

!UnixParallelPort methodsFor: 'as yet unclassified' stamp: 'Richo 8/5/2009 12:32'!
port: aNumber
super port: aNumber.
self setPermissions ! !

!UnixParallelPort methodsFor: 'as yet unclassified' stamp: 'Richo 8/5/2009 12:32'!
setPermissions

	self class apiSetPermissions: self port num: 1 turnOn: 1.! !

ParallelPort subclass: #WinParallelPort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParallelPort-Model'!

!WinParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:20'!
apiClrPortBit: port location: aByte 
	<apicall: void 'ClrPortBit' (short char) module: 'io.dll'>
	^ self externalCallFailed! !

!WinParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:20'!
apiGetPortBit: port location: aByte 
	<apicall: short 'GetPortBit' (short char) module: 'io.dll'>
	^ self externalCallFailed! !

!WinParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:20'!
apiIsDriverInstalled
	<apicall: short 'IsDriverInstalled' () module: 'io.dll'>
	^ self externalCallFailed! !

!WinParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:20'!
apiLeftPortShift: port data: aWord 
	<apicall: short 'LeftPortShift' (short short) module: 'io.dll'>
	^ self externalCallFailed! !

!WinParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:20'!
apiNotPortBit: port location: aByte 
	<apicall: void 'NotPortBit' (short char) module: 'io.dll'>
	^ self externalCallFailed! !

!WinParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:20'!
apiPortDWordIn: port 
	<apicall: longlong 'PortDWordIn' (short) module: 'io.dll'>
	^ self externalCallFailed! !

!WinParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:20'!
apiPortDWordOut: port data: anInteger 
	<apicall: void 'PortDWordOut' (short long) module: 'io.dll'>
	^ self externalCallFailed! !

!WinParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:20'!
apiPortIn: port 
	<apicall: char 'PortIn' (short) module: 'io.dll'>
	^ self externalCallFailed! !

!WinParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:21'!
apiPortOut: port data: aByte 
	<apicall: void 'PortOut' (short char) module: 'io.dll'>
	^ self externalCallFailed! !

!WinParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:21'!
apiPortWordIn: port 
	<apicall: short 'PortWordIn' (short) module: 'io.dll'>
	^ self externalCallFailed! !

!WinParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:21'!
apiPortWordOut: port data: aWord 
	<apicall: void 'PortWordOut' (short short) module: 'io.dll'>
	^ self externalCallFailed! !

!WinParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:21'!
apiRightPortShift: port data: aWord 
	<apicall: short 'RightPortShift' (short short) module: 'io.dll'>
	^ self externalCallFailed! !

!WinParallelPort class methodsFor: '<api>' stamp: 'Richo 8/5/2009 12:21'!
apiSetPortBit: port location: aByte 
	<apicall: void 'SetPortBit' (short char) module: 'io.dll'>
	^ self externalCallFailed! !

!WinParallelPort class methodsFor: 'instance creation' stamp: 'Richo 8/5/2009 12:22'!
new
 ^ self basicNew! !

Player subclass: #GenericParallelPortPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParallelPort-Morph'!

!GenericParallelPortPlayer class methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2010 17:09'!
isUniClass
	^ self ~~ self officialClass! !

!GenericParallelPortPlayer class methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2010 17:09'!
officialClass
	^GenericParallelPortPlayer! !

!GenericParallelPortPlayer class methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2010 17:09'!
wantsChangeSetLogging
	"Log changes for Player itself, but not for automatically-created subclasses like Player1, Player2, but *do* log it for uniclasses that have been manually renamed."

	^ (self == self officialClass or:
		[(self name beginsWith: self officialClass asString) not]) or:
			[Preferences universalTiles]! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin1
	^ self costume renderedMorph getPinState: 1! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin10
	^ self costume renderedMorph getPinState: 10! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin11
	^ self costume renderedMorph getPinState: 11! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin12
	^ self costume renderedMorph getPinState: 12! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin13
	^ self costume renderedMorph getPinState: 13! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin14
	^ self costume renderedMorph getPinState: 14! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin15
	^ self costume renderedMorph getPinState: 15! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin16
	^ self costume renderedMorph getPinState: 16! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin17
	^ self costume renderedMorph getPinState: 17! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin2
	^ self costume renderedMorph getPinState: 2! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin3
	^ self costume renderedMorph getPinState: 3! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin4
	^ self costume renderedMorph getPinState: 4! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin5
	^ self costume renderedMorph getPinState: 5! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin6
	^ self costume renderedMorph getPinState: 6! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin7
	^ self costume renderedMorph getPinState: 7! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin8
	^ self costume renderedMorph getPinState: 8! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 8/6/2009 16:52'!
getPin9
	^ self costume renderedMorph getPinState: 9! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 7/29/2009 13:50'!
setPin14: aBoolean 
	^ self costume renderedMorph set: aBoolean onPin: 14! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 7/29/2009 13:53'!
setPin16: aBoolean 
	^ self costume renderedMorph  set: aBoolean onPin: 16! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 7/29/2009 13:53'!
setPin17: aBoolean 
	^ self costume renderedMorph  set: aBoolean onPin: 17! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 7/29/2009 13:54'!
setPin1: aBoolean 
	^ self costume renderedMorph  set: aBoolean onPin: 1! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 7/29/2009 13:50'!
setPin2: aBoolean 
	^ self costume renderedMorph set: aBoolean onPin: 2! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 7/29/2009 13:53'!
setPin3: aBoolean 
	^ self costume renderedMorph set: aBoolean onPin: 3! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 7/29/2009 13:53'!
setPin4: aBoolean 
	^ self costume renderedMorph  set: aBoolean onPin: 4! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 7/29/2009 13:53'!
setPin5: aBoolean 
	^ self costume renderedMorph set: aBoolean onPin: 5! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 7/29/2009 13:53'!
setPin6: aBoolean 
	^ self costume renderedMorph  set: aBoolean onPin: 6! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 7/29/2009 13:53'!
setPin7: aBoolean 
	^ self costume renderedMorph set: aBoolean onPin: 7! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 7/29/2009 13:53'!
setPin8: aBoolean 
	^ self costume renderedMorph set: aBoolean onPin: 8! !

!GenericParallelPortPlayer methodsFor: 'slots' stamp: 'Richo 7/29/2009 13:50'!
setPin9: aBoolean 
	^ self costume renderedMorph  set: aBoolean onPin: 9! !
UnixParallelPort initialize!
